# autogenerated by ssc-gen DO NOT_EDIT
"""universal parser for kodik.info/serial entrypoint"""

import re
import json
from typing import List, Dict, TypedDict, Union


from parsel import Selector, SelectorList

J_UrlParams = TypedDict(
    "J_UrlParams",
    {
        "d": str,
        "d_sign": str,
        "pd": str,
        "pd_sign": str,
        "ref": str,
        "ref_sign": str,
        "advert_debug": bool,
        "min_age": int,
        "first_url": bool,
    },
)
T_KodikAPIPayload = TypedDict(
    "T_KodikAPIPayload",
    {
        "d": str,
        "d_sign": str,
        "pd": str,
        "pd_sign": str,
        "ref": str,
        "ref_sign": str,
        "type": str,
        "hash": str,
        "id": str,
    },
)
T_SeasonBox = TypedDict(
    "T_SeasonBox",
    {
        "value": str,
        "data_serial_id": str,
        "data_serial_hash": str,
        "data_title": str,
        "data_translation_title": str,
    },
)
T_SeriesBox = TypedDict(
    "T_SeriesBox",
    {
        "value": str,
        "data_id": str,
        "data_hash": str,
        "data_title": str,
    },
)
T_SeriesOptionItem = TypedDict(
    "T_SeriesOptionItem",
    {
        "value": str,
        "data_id": str,
        "data_hash": str,
        "data_title": str,
    },
)
T_SeriesOptions = Dict[str, List[T_SeriesOptionItem]]
T_TranslationsBox = TypedDict(
    "T_TranslationsBox",
    {
        "value": str,
        "data_id": str,
        "data_translation_type": str,
        "data_media_id": str,
        "data_media_hash": str,
        "data_media_type": str,
        "data_title": str,
        "data_episode_count": str,
    },
)
T_MainKodikMin = TypedDict(
    "T_MainKodikMin",
    {
        "url_params": J_UrlParams,
        "api_payload": T_KodikAPIPayload,
        "player_js_path": str,
    },
)
T_MainKodikSerialPage = TypedDict(
    "T_MainKodikSerialPage",
    {
        "thumbnails": List[str],
        "season_box": List[T_SeasonBox],
        "series_box": List[T_SeriesBox],
        "series_options": T_SeriesOptions,
        "translations_box": List[T_TranslationsBox],
        "url_params": J_UrlParams,
        "api_payload": T_KodikAPIPayload,
        "player_js_path": str,
    },
)
T_MovieTranslationBox = TypedDict(
    "T_MovieTranslationBox",
    {
        "value": str,
        "data_id": str,
        "data_translation_type": str,
        "data_media_id": str,
        "data_media_hash": str,
        "data_media_type": str,
        "data_title": str,
    },
)
T_MainKodikVideoPage = TypedDict(
    "T_MainKodikVideoPage",
    {
        "thumbnails": List[str],
        "translation_box": List[T_MovieTranslationBox],
        "url_params": J_UrlParams,
        "api_payload": T_KodikAPIPayload,
        "player_js_path": str,
    },
)
T_MainKodikAPIPath = TypedDict(
    "T_MainKodikAPIPath",
    {
        "api_path": str,
    },
)


class KodikAPIPayload:
    """payload for Kodik API request

    {
        "d": "String",
        "d_sign": "String",
        "pd": "String",
        "pd_sign": "String",
        "ref": "String",
        "ref_sign": "String",
        "type": "String",
        "hash": "String",
        "id": "String"
    }"""

    def __init__(self, document: Union[str, Selector, SelectorList]) -> None:
        self._document = Selector(document) if isinstance(document, str) else document

    def _parse_d(self, v: Union[Selector, SelectorList]) -> str:
        v0 = v.get()
        return re.search(r"var\s*domain\s+=\s+[\'\"](.*?)[\'\"];", v0)[1]

    def _parse_d_sign(self, v: Union[Selector, SelectorList]) -> str:
        v0 = v.get()
        return re.search(r"var\s*d_sign\s+=\s+[\'\"](.*?)[\'\"];", v0)[1]

    def _parse_pd(self, v: Union[Selector, SelectorList]) -> str:
        v0 = v.get()
        return re.search(r"var\s*pd\s+=\s+[\'\"](.*?)[\'\"];", v0)[1]

    def _parse_pd_sign(self, v: Union[Selector, SelectorList]) -> str:
        v0 = v.get()
        return re.search(r"var\s*pd_sign\s+=\s+[\'\"](.*?)[\'\"];", v0)[1]

    def _parse_ref(self, v: Union[Selector, SelectorList]) -> str:
        v0 = v.get()
        return re.search(r"var\s*ref\s+=\s+[\'\"](.*?)[\'\"];", v0)[1]

    def _parse_ref_sign(self, v: Union[Selector, SelectorList]) -> str:
        v0 = v.get()
        return re.search(r"var\s*ref_sign\s+=\s+[\'\"](.*?)[\'\"];", v0)[1]

    def _parse_type(self, v: Union[Selector, SelectorList]) -> str:
        v0 = v.get()
        return re.search(r"videoInfo\.type\s*=\s*[\'\"](.*?)[\'\"];", v0)[1]

    def _parse_hash(self, v: Union[Selector, SelectorList]) -> str:
        v0 = v.get()
        return re.search(r"videoInfo\.hash\s*=\s*[\'\"](.*?)[\'\"];", v0)[1]

    def _parse_id(self, v: Union[Selector, SelectorList]) -> str:
        v0 = v.get()
        return re.search(r"videoInfo\.id\s*=\s*[\'\"](.*?)[\'\"];", v0)[1]

    def parse(self) -> T_KodikAPIPayload:
        return {
            "d": self._parse_d(self._document),
            "d_sign": self._parse_d_sign(self._document),
            "pd": self._parse_pd(self._document),
            "pd_sign": self._parse_pd_sign(self._document),
            "ref": self._parse_ref(self._document),
            "ref_sign": self._parse_ref_sign(self._document),
            "type": self._parse_type(self._document),
            "hash": self._parse_hash(self._document),
            "id": self._parse_id(self._document),
        }


class SeasonBox:
    """represent season select

    [
        {
            "value": "String",
            "data_serial_id": "String",
            "data_serial_hash": "String",
            "data_title": "String",
            "data_translation_title": "String"
        },
        "..."
    ]"""

    def __init__(self, document: Union[str, Selector, SelectorList]) -> None:
        self._document = Selector(document) if isinstance(document, str) else document

    def _split_doc(self, v: Union[Selector, SelectorList]) -> SelectorList:
        return v.css("option")

    def _parse_value(self, v: Union[Selector, SelectorList]) -> str:
        return v.attrib["value"]

    def _parse_data_serial_id(self, v: Union[Selector, SelectorList]) -> str:
        return v.attrib["data-serial-id"]

    def _parse_data_serial_hash(self, v: Union[Selector, SelectorList]) -> str:
        return v.attrib["data-serial-hash"]

    def _parse_data_title(self, v: Union[Selector, SelectorList]) -> str:
        return v.attrib["data-title"]

    def _parse_data_translation_title(self, v: Union[Selector, SelectorList]) -> str:
        return v.attrib["data-translation-title"]

    def parse(self) -> List[T_SeasonBox]:
        return [
            {
                "value": self._parse_value(el),
                "data_serial_id": self._parse_data_serial_id(el),
                "data_serial_hash": self._parse_data_serial_hash(el),
                "data_title": self._parse_data_title(el),
                "data_translation_title": self._parse_data_translation_title(el),
            }
            for el in self._split_doc(self._document)
        ]


class SeriesBox:
    """represent selected series in current page

    [
        {
            "value": "String",
            "data_id": "String",
            "data_hash": "String",
            "data_title": "String"
        },
        "..."
    ]"""

    def __init__(self, document: Union[str, Selector, SelectorList]) -> None:
        self._document = Selector(document) if isinstance(document, str) else document

    def _split_doc(self, v: Union[Selector, SelectorList]) -> SelectorList:
        return v.css("option")

    def _parse_value(self, v: Union[Selector, SelectorList]) -> str:
        return v.attrib["value"]

    def _parse_data_id(self, v: Union[Selector, SelectorList]) -> str:
        return v.attrib["data-id"]

    def _parse_data_hash(self, v: Union[Selector, SelectorList]) -> str:
        return v.attrib["data-hash"]

    def _parse_data_title(self, v: Union[Selector, SelectorList]) -> str:
        return v.attrib["data-title"]

    def parse(self) -> List[T_SeriesBox]:
        return [
            {
                "value": self._parse_value(el),
                "data_id": self._parse_data_id(el),
                "data_hash": self._parse_data_hash(el),
                "data_title": self._parse_data_title(el),
            }
            for el in self._split_doc(self._document)
        ]


class SeriesOptionItem:
    """

    [
        {
            "value": "String",
            "data_id": "String",
            "data_hash": "String",
            "data_title": "String"
        },
        "..."
    ]"""

    def __init__(self, document: Union[str, Selector, SelectorList]) -> None:
        self._document = Selector(document) if isinstance(document, str) else document

    def _split_doc(self, v: Union[Selector, SelectorList]) -> SelectorList:
        return v.css("option")

    def _parse_value(self, v: Union[Selector, SelectorList]) -> str:
        return v.attrib["value"]

    def _parse_data_id(self, v: Union[Selector, SelectorList]) -> str:
        return v.attrib["data-id"]

    def _parse_data_hash(self, v: Union[Selector, SelectorList]) -> str:
        return v.attrib["data-hash"]

    def _parse_data_title(self, v: Union[Selector, SelectorList]) -> str:
        return v.attrib["data-title"]

    def parse(self) -> List[T_SeriesOptionItem]:
        return [
            {
                "value": self._parse_value(el),
                "data_id": self._parse_data_id(el),
                "data_hash": self._parse_data_hash(el),
                "data_title": self._parse_data_title(el),
            }
            for el in self._split_doc(self._document)
        ]


class SeriesOptions:
    """

    {
        "<K>": [
            {
                "value": "String",
                "data_id": "String",
                "data_hash": "String",
                "data_title": "String"
            },
            "..."
        ],
        "<KN>": "..."
    }"""

    def __init__(self, document: Union[str, Selector, SelectorList]) -> None:
        self._document = Selector(document) if isinstance(document, str) else document

    def _split_doc(self, v: Union[Selector, SelectorList]) -> SelectorList:
        return v.css("div")

    def _parse_key(self, v: Union[Selector, SelectorList]) -> str:
        return v.attrib["class"]

    def _parse_value(self, v: Union[Selector, SelectorList]) -> List[T_SeriesOptionItem]:
        return SeriesOptionItem(v).parse()

    def parse(self) -> T_SeriesOptions:
        return {self._parse_key(el): self._parse_value(el) for el in self._split_doc(self._document)}


class TranslationsBox:
    """

    [
        {
            "value": "String",
            "data_id": "String",
            "data_translation_type": "String",
            "data_media_id": "String",
            "data_media_hash": "String",
            "data_media_type": "String",
            "data_title": "String",
            "data_episode_count": "String"
        },
        "..."
    ]"""

    def __init__(self, document: Union[str, Selector, SelectorList]) -> None:
        self._document = Selector(document) if isinstance(document, str) else document

    def _split_doc(self, v: Union[Selector, SelectorList]) -> SelectorList:
        return v.css("option")

    def _parse_value(self, v: Union[Selector, SelectorList]) -> str:
        return v.attrib["value"]

    def _parse_data_id(self, v: Union[Selector, SelectorList]) -> str:
        return v.attrib["data-id"]

    def _parse_data_translation_type(self, v: Union[Selector, SelectorList]) -> str:
        return v.attrib["data-translation-type"]

    def _parse_data_media_id(self, v: Union[Selector, SelectorList]) -> str:
        return v.attrib["data-media-id"]

    def _parse_data_media_hash(self, v: Union[Selector, SelectorList]) -> str:
        return v.attrib["data-media-hash"]

    def _parse_data_media_type(self, v: Union[Selector, SelectorList]) -> str:
        return v.attrib["data-media-type"]

    def _parse_data_title(self, v: Union[Selector, SelectorList]) -> str:
        return v.attrib["data-title"]

    def _parse_data_episode_count(self, v: Union[Selector, SelectorList]) -> str:
        v0 = v.attrib["data-episode-count"]
        return re.search(r"(\d+)$", v0)[1]

    def parse(self) -> List[T_TranslationsBox]:
        return [
            {
                "value": self._parse_value(el),
                "data_id": self._parse_data_id(el),
                "data_translation_type": self._parse_data_translation_type(el),
                "data_media_id": self._parse_data_media_id(el),
                "data_media_hash": self._parse_data_media_hash(el),
                "data_media_type": self._parse_data_media_type(el),
                "data_title": self._parse_data_title(el),
                "data_episode_count": self._parse_data_episode_count(el),
            }
            for el in self._split_doc(self._document)
        ]


class MainKodikMin:
    """parser for extract only minimal data for next API reuqest

        for extract full detailed information use MainKodikSerialPage and MainKodikVideoPage

        USAGE:

            1. GET <kodik-page-player>
            2. add base_url to <player_js_path>
            3. extract API (<API_PATH>) path from javascript file (use MainKodikAPIPath)
            3.1 decode <API_PATH> path (base64 cipher)
            4. <api_payload> required extra constant keys
                - bad_user = (true or false)
                - cdn_is_working = true
                - info "{}"
            4.1 required headers:
                - origin="https://<NETLOC>" // player page
                - referer=<PLAYER_LINK> // FIRST URL player entrypoint
                - accept= "application/json, text/javascript, */*; q=0.01"
            4.2 POST <kodik-base-url> + /<API_PATH>
               data=<api_payload> (<JSON>) + headers
            5. extract urls from ['links'] key
            6. video urls encoded in ROT_13 + BASE64 ciphers

        EXAMPLE:

            - GET https://kodik.info/serial/64218/890744b309ec026d43742995d0d49cd7/720p?season=1&episode=1
            - GET https://aniqit.com/video/72755/dc966c03a7cb719dac577d8004a9b091/720p
            - GET https://kodik.info/seria/1133512/04d5f7824ba3563bd78e44a22451bb45/720p

         ISSUES:
            - kodik maybe have another netloc (e.g.: anivod)
            - 403 Forbidden if request sent not from CIS region
            - 404 DELETED: eg: https://kodik.info/seria/310427/09985563d891b56b1e9b01142ae11872/720p
            - 500 Internal server error: eg: https://kodik.info/seria/1051016/af405efc5e061f5ac344d4811de3bc16/720p ('Cyberpunk: Edgerunners' ep5 Anilibria dub)




    {
        "url_params": {
            "d": "String",
            "d_sign": "String",
            "pd": "String",
            "pd_sign": "String",
            "ref": "String",
            "ref_sign": "String",
            "advert_debug": "Bool",
            "min_age": "Int",
            "first_url": "Bool"
        },
        "api_payload": {
            "d": "String",
            "d_sign": "String",
            "pd": "String",
            "pd_sign": "String",
            "ref": "String",
            "ref_sign": "String",
            "type": "String",
            "hash": "String",
            "id": "String"
        },
        "player_js_path": "String"
    }"""

    def __init__(self, document: Union[str, Selector, SelectorList]) -> None:
        self._document = Selector(document) if isinstance(document, str) else document

    def _parse_url_params(self, v: Union[Selector, SelectorList]) -> J_UrlParams:
        v0 = v.get()
        v1 = re.search("var\\s*urlParams\\s*=\\s*['\\\"](\\{.*\\})['\\\"]", v0)[1]
        return json.loads(v1)

    def _parse_api_payload(self, v: Union[Selector, SelectorList]) -> T_KodikAPIPayload:
        return KodikAPIPayload(v).parse()

    def _parse_player_js_path(self, v: Union[Selector, SelectorList]) -> str:
        v0 = v.get()
        return re.search(r'<script\s*type="text/javascript"\s*src="(/assets/js/app\..*?)">', v0)[1]

    def parse(self) -> T_MainKodikMin:
        return {
            "url_params": self._parse_url_params(self._document),
            "api_payload": self._parse_api_payload(self._document),
            "player_js_path": self._parse_player_js_path(self._document),
        }


class MainKodikSerialPage:
    """first extract data entrypoint for kodik.../serial/ entrypoint path

    {
        "thumbnails": "Array<String>",
        "season_box": [
            {
                "value": "String",
                "data_serial_id": "String",
                "data_serial_hash": "String",
                "data_title": "String",
                "data_translation_title": "String"
            },
            "..."
        ],
        "series_box": [
            {
                "value": "String",
                "data_id": "String",
                "data_hash": "String",
                "data_title": "String"
            },
            "..."
        ],
        "series_options": {
            "<K>": [
                {
                    "value": "String",
                    "data_id": "String",
                    "data_hash": "String",
                    "data_title": "String"
                },
                "..."
            ],
            "<KN>": "..."
        },
        "translations_box": [
            {
                "value": "String",
                "data_id": "String",
                "data_translation_type": "String",
                "data_media_id": "String",
                "data_media_hash": "String",
                "data_media_type": "String",
                "data_title": "String",
                "data_episode_count": "String"
            },
            "..."
        ],
        "url_params": {
            "d": "String",
            "d_sign": "String",
            "pd": "String",
            "pd_sign": "String",
            "ref": "String",
            "ref_sign": "String",
            "advert_debug": "Bool",
            "min_age": "Int",
            "first_url": "Bool"
        },
        "api_payload": {
            "d": "String",
            "d_sign": "String",
            "pd": "String",
            "pd_sign": "String",
            "ref": "String",
            "ref_sign": "String",
            "type": "String",
            "hash": "String",
            "id": "String"
        },
        "player_js_path": "String"
    }"""

    def __init__(self, document: Union[str, Selector, SelectorList]) -> None:
        self._document = Selector(document) if isinstance(document, str) else document

    def _parse_thumbnails(self, v: Union[Selector, SelectorList]) -> List[str]:
        v0 = v.get()
        v1 = re.search("var\\s*thumbnails\\s*=\\s*\\[(.*?)\\];", v0)[1]
        v2 = v1.replace('"', "")
        v3 = v2.split(",")
        v4 = [i.strip(" ") for i in v3]
        return [f"https:{i}" for i in v4]

    def _parse_season_box(self, v: Union[Selector, SelectorList]) -> List[T_SeasonBox]:
        v0 = v.css(".serial-panel > .serial-seasons-box")
        return SeasonBox(v0).parse()

    def _parse_series_box(self, v: Union[Selector, SelectorList]) -> List[T_SeriesBox]:
        v0 = v.css(".serial-panel > .serial-series-box")
        return SeriesBox(v0).parse()

    def _parse_series_options(self, v: Union[Selector, SelectorList]) -> T_SeriesOptions:
        v0 = v.css(".serial-panel > .series-options")
        return SeriesOptions(v0).parse()

    def _parse_translations_box(self, v: Union[Selector, SelectorList]) -> List[T_TranslationsBox]:
        v0 = v.css(".serial-panel > .serial-translations-box")
        return TranslationsBox(v0).parse()

    def _parse_url_params(self, v: Union[Selector, SelectorList]) -> J_UrlParams:
        v0 = v.get()
        v1 = re.search("var\\s*urlParams\\s*=\\s*['\\\"](\\{.*\\})['\\\"]", v0)[1]
        return json.loads(v1)

    def _parse_api_payload(self, v: Union[Selector, SelectorList]) -> T_KodikAPIPayload:
        return KodikAPIPayload(v).parse()

    def _parse_player_js_path(self, v: Union[Selector, SelectorList]) -> str:
        v0 = v.get()
        return re.search(r'<script\s*type="text/javascript"\s*src="(/assets/js/app\..*?)">', v0)[1]

    def parse(self) -> T_MainKodikSerialPage:
        return {
            "thumbnails": self._parse_thumbnails(self._document),
            "season_box": self._parse_season_box(self._document),
            "series_box": self._parse_series_box(self._document),
            "series_options": self._parse_series_options(self._document),
            "translations_box": self._parse_translations_box(self._document),
            "url_params": self._parse_url_params(self._document),
            "api_payload": self._parse_api_payload(self._document),
            "player_js_path": self._parse_player_js_path(self._document),
        }


class MovieTranslationBox:
    """

    [
        {
            "value": "String",
            "data_id": "String",
            "data_translation_type": "String",
            "data_media_id": "String",
            "data_media_hash": "String",
            "data_media_type": "String",
            "data_title": "String"
        },
        "..."
    ]"""

    def __init__(self, document: Union[str, Selector, SelectorList]) -> None:
        self._document = Selector(document) if isinstance(document, str) else document

    def _split_doc(self, v: Union[Selector, SelectorList]) -> SelectorList:
        return v.css("option")

    def _parse_value(self, v: Union[Selector, SelectorList]) -> str:
        return v.attrib["value"]

    def _parse_data_id(self, v: Union[Selector, SelectorList]) -> str:
        return v.attrib["data-id"]

    def _parse_data_translation_type(self, v: Union[Selector, SelectorList]) -> str:
        return v.attrib["data-translation-type"]

    def _parse_data_media_id(self, v: Union[Selector, SelectorList]) -> str:
        return v.attrib["data-media-id"]

    def _parse_data_media_hash(self, v: Union[Selector, SelectorList]) -> str:
        return v.attrib["data-media-hash"]

    def _parse_data_media_type(self, v: Union[Selector, SelectorList]) -> str:
        return v.attrib["data-media-type"]

    def _parse_data_title(self, v: Union[Selector, SelectorList]) -> str:
        return v.attrib["data-title"]

    def parse(self) -> List[T_MovieTranslationBox]:
        return [
            {
                "value": self._parse_value(el),
                "data_id": self._parse_data_id(el),
                "data_translation_type": self._parse_data_translation_type(el),
                "data_media_id": self._parse_data_media_id(el),
                "data_media_hash": self._parse_data_media_hash(el),
                "data_media_type": self._parse_data_media_type(el),
                "data_title": self._parse_data_title(el),
            }
            for el in self._split_doc(self._document)
        ]


class MainKodikVideoPage:
    """first extract data entrypoint for kodik.../video/ entrypoint path

        required for extract videos via kodik API


    {
        "thumbnails": "Array<String>",
        "translation_box": [
            {
                "value": "String",
                "data_id": "String",
                "data_translation_type": "String",
                "data_media_id": "String",
                "data_media_hash": "String",
                "data_media_type": "String",
                "data_title": "String"
            },
            "..."
        ],
        "url_params": {
            "d": "String",
            "d_sign": "String",
            "pd": "String",
            "pd_sign": "String",
            "ref": "String",
            "ref_sign": "String",
            "advert_debug": "Bool",
            "min_age": "Int",
            "first_url": "Bool"
        },
        "api_payload": {
            "d": "String",
            "d_sign": "String",
            "pd": "String",
            "pd_sign": "String",
            "ref": "String",
            "ref_sign": "String",
            "type": "String",
            "hash": "String",
            "id": "String"
        },
        "player_js_path": "String"
    }"""

    def __init__(self, document: Union[str, Selector, SelectorList]) -> None:
        self._document = Selector(document) if isinstance(document, str) else document

    def _parse_thumbnails(self, v: Union[Selector, SelectorList]) -> List[str]:
        v0 = v.get()
        v1 = re.search("var\\s*thumbnails\\s*=\\s*\\[(.*?)\\];", v0)[1]
        v2 = v1.replace('"', "")
        v3 = v2.split(",")
        v4 = [i.strip(" ") for i in v3]
        return [f"https:{i}" for i in v4]

    def _parse_translation_box(self, v: Union[Selector, SelectorList]) -> List[T_MovieTranslationBox]:
        v0 = v.css(".movie-panel > .movie-translations-box")
        return MovieTranslationBox(v0).parse()

    def _parse_url_params(self, v: Union[Selector, SelectorList]) -> J_UrlParams:
        v0 = v.get()
        v1 = re.search("var\\s*urlParams\\s*=\\s*['\\\"](\\{.*\\})['\\\"]", v0)[1]
        return json.loads(v1)

    def _parse_api_payload(self, v: Union[Selector, SelectorList]) -> T_KodikAPIPayload:
        return KodikAPIPayload(v).parse()

    def _parse_player_js_path(self, v: Union[Selector, SelectorList]) -> str:
        v0 = v.get()
        return re.search(r'<script\s*type="text/javascript"\s*src="(/assets/js/app\..*?)">', v0)[1]

    def parse(self) -> T_MainKodikVideoPage:
        return {
            "thumbnails": self._parse_thumbnails(self._document),
            "translation_box": self._parse_translation_box(self._document),
            "url_params": self._parse_url_params(self._document),
            "api_payload": self._parse_api_payload(self._document),
            "player_js_path": self._parse_player_js_path(self._document),
        }


class MainKodikAPIPath:
    """extract actual API path from kodik js script

        USAGE:

            GET MainKodikPage.player_js_path, MainKodikSerialPage.player_js_path

        EXAMPLE:

            - GET https://kodik.info/assets/js/app.serial.6721f2dd68501a625a518ea935006bd8f5cf5f4d037f2648a97a02dfd0fe5b85.js
            - GET https://aniqit.com/assets/js/app.player_single.3e2f9f0ae45d18b06cfd8b01181f85bab47fb9867cd1e73568c84dbe44ba7a44.js



    {
        "api_path": "String"
    }"""

    def __init__(self, document: Union[str, Selector, SelectorList]) -> None:
        self._document = Selector(document) if isinstance(document, str) else document

    def _parse_api_path(self, v: Union[Selector, SelectorList]) -> str:
        v0 = v.get()
        return re.search(r"\$\.ajax\([^>]+,url:\s*atob\([\"\']([\w=]+)[\"\']\)", v0)[1]

    def parse(self) -> T_MainKodikAPIPath:
        return {
            "api_path": self._parse_api_path(self._document),
        }
